---
title: Get report results - results in file - polling
description: After running the report creation request, poll with GET {{apiPath}}/v1/environments/{{envID}}/dataExplorations/{{dataExplorationID}}, using the ID that was returned when you created the report, until the status field in the response equals SUCCESS.
component: pingone-api
page_id: pingone-api:mfa:users/mfa-reports/get_report_results_as_file_polling
canonical_url: https://developer.pingidentity.com/pingone-api/mfa/users/mfa-reports/get_report_results_as_file_polling.html
section_ids:
  headers: Headers
  example-request: Example Request
  example-response: Example Response
---

# Get report results - results in file - polling

##

```none
GET {{apiPath}}/v1/environments/{{envID}}/dataExplorations/{{dataExplorationID}}
```

After running the report creation request, poll with `GET {{apiPath}}/v1/environments/{{envID}}/dataExplorations/{{dataExplorationID}}`, using the ID that was returned when you created the report, until the `status` field in the response equals `SUCCESS`.

When the response contains the status `SUCCESS`, it will also include a link for downloading a zipped csv file, a link for downloading a zipped JSON file, and a password for opening the zip files. Use this information to download and unzip the report.

The links in the response are only valid for five minutes. If more than five minutes has elapsed from the time of the request that returned the links, get updated links by running the request again.

### Headers

Authorization      Bearer {{accessToken}}

##

### Example Request

* cURL

* C#

* Go

* HTTP

* Java

* jQuery

* NodeJS

* Python

* PHP

* Ruby

* Swift

```shell
curl --location --globoff '{{apiPath}}/v1/environments/{{envID}}/dataExplorations/{{dataExplorationID}}' \
--header 'Authorization: Bearer {{accessToken}}'
```

```csharp
var options = new RestClientOptions("{{apiPath}}/v1/environments/{{envID}}/dataExplorations/{{dataExplorationID}}")
{
  MaxTimeout = -1,
};
var client = new RestClient(options);
var request = new RestRequest("", Method.Get);
request.AddHeader("Authorization", "Bearer {{accessToken}}");
RestResponse response = await client.ExecuteAsync(request);
Console.WriteLine(response.Content);
```

```golang
package main

import (
  "fmt"
  "net/http"
  "io"
)

func main() {

  url := "{{apiPath}}/v1/environments/{{envID}}/dataExplorations/{{dataExplorationID}}"
  method := "GET"

  client := &http.Client {
  }
  req, err := http.NewRequest(method, url, nil)

  if err != nil {
    fmt.Println(err)
    return
  }
  req.Header.Add("Authorization", "Bearer {{accessToken}}")

  res, err := client.Do(req)
  if err != nil {
    fmt.Println(err)
    return
  }
  defer res.Body.Close()

  body, err := io.ReadAll(res.Body)
  if err != nil {
    fmt.Println(err)
    return
  }
  fmt.Println(string(body))
}
```

```http
GET /v1/environments/{{envID}}/dataExplorations/{{dataExplorationID}} HTTP/1.1
Host: {{apiPath}}
Authorization: Bearer {{accessToken}}
```

```java
OkHttpClient client = new OkHttpClient().newBuilder()
  .build();
MediaType mediaType = MediaType.parse("text/plain");
RequestBody body = RequestBody.create(mediaType, "");
Request request = new Request.Builder()
  .url("{{apiPath}}/v1/environments/{{envID}}/dataExplorations/{{dataExplorationID}}")
  .method("GET", body)
  .addHeader("Authorization", "Bearer {{accessToken}}")
  .build();
Response response = client.newCall(request).execute();
```

```javascript
var settings = {
  "url": "{{apiPath}}/v1/environments/{{envID}}/dataExplorations/{{dataExplorationID}}",
  "method": "GET",
  "timeout": 0,
  "headers": {
    "Authorization": "Bearer {{accessToken}}"
  },
};

$.ajax(settings).done(function (response) {
  console.log(response);
});
```

```javascript
var request = require('request');
var options = {
  'method': 'GET',
  'url': '{{apiPath}}/v1/environments/{{envID}}/dataExplorations/{{dataExplorationID}}',
  'headers': {
    'Authorization': 'Bearer {{accessToken}}'
  }
};
request(options, function (error, response) {
  if (error) throw new Error(error);
  console.log(response.body);
});
```

```python
import requests

url = "{{apiPath}}/v1/environments/{{envID}}/dataExplorations/{{dataExplorationID}}"

payload = {}
headers = {
  'Authorization': 'Bearer {{accessToken}}'
}

response = requests.request("GET", url, headers=headers, data=payload)

print(response.text)
```

```php
<?php
require_once 'HTTP/Request2.php';
$request = new HTTP_Request2();
$request->setUrl('{{apiPath}}/v1/environments/{{envID}}/dataExplorations/{{dataExplorationID}}');
$request->setMethod(HTTP_Request2::METHOD_GET);
$request->setConfig(array(
  'follow_redirects' => TRUE
));
$request->setHeader(array(
  'Authorization' => 'Bearer {{accessToken}}'
));
try {
  $response = $request->send();
  if ($response->getStatus() == 200) {
    echo $response->getBody();
  }
  else {
    echo 'Unexpected HTTP status: ' . $response->getStatus() . ' ' .
    $response->getReasonPhrase();
  }
}
catch(HTTP_Request2_Exception $e) {
  echo 'Error: ' . $e->getMessage();
}
```

```ruby
require "uri"
require "net/http"

url = URI("{{apiPath}}/v1/environments/{{envID}}/dataExplorations/{{dataExplorationID}}")

http = Net::HTTP.new(url.host, url.port);
request = Net::HTTP::Get.new(url)
request["Authorization"] = "Bearer {{accessToken}}"

response = http.request(request)
puts response.read_body
```

```swift
var request = URLRequest(url: URL(string: "{{apiPath}}/v1/environments/{{envID}}/dataExplorations/{{dataExplorationID}}")!,timeoutInterval: Double.infinity)
request.addValue("Bearer {{accessToken}}", forHTTPHeaderField: "Authorization")

request.httpMethod = "GET"

let task = URLSession.shared.dataTask(with: request) { data, response, error in
  guard let data = data else {
    print(String(describing: error))
    return
  }
  print(String(data: data, encoding: .utf8)!)
}

task.resume()
```

### Example Response

200 OK

```json
{
    "_links": {
        "self": {
            "href": "https://api.pingone.eu/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/dataExplorations/0fe52654-ff7a-4c90-8d80-1af1a745c097"
        },
        "environment": {
            "href": "https://api.pingone.eu/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6"
        },
        "dataExplorationTemplate": {
            "href": "https://api.pingone.eu/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/dataExplorationTemplates/db632bfd-7054-4bde-b108-a384aac2d513"
        }
    },
    "id": "0fe52654-ff7a-4c90-8d80-1af1a745c097",
    "environment": {
        "id": "abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6"
    },
    "createdAt": "2023-10-16T11:51:26.000Z",
    "updatedAt": "2023-10-16T11:51:31.600Z",
    "expiresAt": "2023-10-16T12:21:26.000Z",
    "fields": [
        {
            "name": "userId"
        },
        {
            "name": "username"
        },
        {
            "name": "phone"
        },
        {
            "name": "deviceStatus"
        },
        {
            "name": "deviceId"
        }
    ],
    "filter": "(mfaEnabled eq \"true\")",
    "orderBy": [],
    "status": "SUCCESS",
    "deliverAs": "ASYNC_FILE",
    "zipPassword": "pezeekamil",
    "csvPresignedUrl": "https://p1-reports-prod-eu-central-1.s3.eu-central-1.amazonaws.com/devices-report-abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6-36533550-b284-4ad5-ae59-0b7cfa73cacb.csv.zip?X-Amz-Security-Token=ATotallyFakeAWSSecurityTokenUnlikelyToBeMistakenFor%2F19c8JNwHWIhwaooowQbyclH8pIdNXR5y9CdPzFgNgkaiKnrBV6t02RZyg7O5%2B8Q8kdhwmeRYE9DL7oi19C4rbFZoUoFD5H5o3aydZyHxXeeZ%2BgPDL4u1KCQace5pb1exUtyEjeU3a9%2Fdaljeqv%2FUZHlXrptn3Qs7dW8dBvEmJdlLpB3bNXv4%2BRxizZa5CN%2Bvh%2FCCFk6EmSBxCh7atTSiJv5pVNe7J0DSfn1YHbMPDoKimfeWqM6avCwoxcK0qQYyLY8hItt5qasdUYqQPSqxb0sXKJJ%2BUYN%2Fr73WRSZiVv45YeG9q3aAz8DIxsLIqQ%3D%3D&X-Amz-Algorithm=AWS4-HMAC-SHA256&X-Amz-Date=20231016T115232Z&X-Amz-SignedHeaders=host&X-Amz-Expires=300&X-Amz-Credential=ATotallyFakeAWSToken%2F20231016%2Feu-central-1%2Fs3%2Faws4_request&X-Amz-Signature=0900e76894cb29b67b108ac26dd743c4f79201c141247be721029476e24168e2",
    "jsonPresignedUrl": "https://p1-reports-prod-eu-central-1.s3.eu-central-1.amazonaws.com/devices-report-abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6-36533550-b284-4ad5-ae59-0b7cfa73cacb.json.zip?X-Amz-Security-Token=ATotallyFakeAWSSecurityTokenUnlikelyToBeMistakenFor%2F19c8JNwHWIhwaooowQbyclH8pIdNXR5y9CdPzFgNgkaiKnrBV6t02RZyg7O5%2B8Q8kdhwmeRYE9DL7oi19C4rbFZoUoFD5H5o3aydZyHxXeeZ%2BgPDL4u1KCQace5pb1exUtyEjeU3a9%2Fdaljeqv%2FUZHlXrptn3Qs7dW8dBvEmJdlLpB3bNXv4%2BRxizZa5CN%2Bvh%2FCCFk6EmSBxCh7atTSiJv5pVNe7J0DSfn1YHbMPDoKimfeWqM6avCwoxcK0qQYyLY8hItt5qasdUYqQPSqxb0sXKJJ%2BUYN%2Fr73WRSZiVv45YeG9q3aAz8DIxsLIqQ%3D%3D&X-Amz-Algorithm=AWS4-HMAC-SHA256&X-Amz-Date=20231016T115232Z&X-Amz-SignedHeaders=host&X-Amz-Expires=300&X-Amz-Credential=ATotallyFakeAWSToken%2F20231016%2Feu-central-1%2Fs3%2Faws4_request&X-Amz-Signature=88b894f1889511fa9b0aa81d684ad4f0a6803d7c4f6a6b68e27b9d874598fe10",
    "sync": false,
    "dataExplorationTemplate": {
        "id": "db632bfd-7054-4bde-b108-a384aac2d513",
        "name": "Devices report"
    }
}
```
